-- Este multiplexor selecciona el bus de entrada que aparecer en el bus de
-- salida (B2) de acuerdo con las entradas de seleccin 'bh'.

LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_signed.all;

ENTITY dec_bin IS
PORT(b,h:IN std_logic;
	 qReg,DR,PC,IR: IN STD_LOGIC_VECTOR(15 DOWNTO 0);
	 B2:OUT STD_LOGIC_VECTOR(15 DOWNTO 0));
END dec_bin;

ARCHITECTURE x OF dec_bin IS

BEGIN

	B2 <= qReg WHEN b='0' AND h='0' ELSE 
		  DR WHEN b='0' AND h='1' ELSE 
		  PC WHEN b='1' AND h='0' ELSE 
		  IR WHEN b='1' AND h='1';

END x;

-- 48 LCs (4 %)
