-- Este decodificador se encarga de decodificar el cdigo de operacin de cada
-- instruccin (codop) para generar las seales que serviran de entrada
-- a la Lgica Combinacional de Control.

LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_signed.all;

ENTITY decod IS
PORT(codop:IN std_logic_vector(3 downto 0);
	 I0,I1,I2,I3,I4,I5,I6,I7:OUT std_logic;
	 I8,I9,IA,IB,IC,ID,IE,I_F:OUT std_logic);
END decod;

ARCHITECTURE x OF decod IS

BEGIN

	I0 <= '1' WHEN codop="0000" ELSE '0';
	I1 <= '1' WHEN codop="0001" ELSE '0';
	I2 <= '1' WHEN codop="0010" ELSE '0';
	I3 <= '1' WHEN codop="0011" ELSE '0';
	I4 <= '1' WHEN codop="0100" ELSE '0';
	I5 <= '1' WHEN codop="0101" ELSE '0';
	I6 <= '1' WHEN codop="0110" ELSE '0';
	I7 <= '1' WHEN codop="0111" ELSE '0';
	I8 <= '1' WHEN codop="1000" ELSE '0';
	I9 <= '1' WHEN codop="1001" ELSE '0';
	IA <= '1' WHEN codop="1010" ELSE '0';
	IB <= '1' WHEN codop="1011" ELSE '0';
	IC <= '1' WHEN codop="1100" ELSE '0';
	ID <= '1' WHEN codop="1101" ELSE '0';
	IE <= '1' WHEN codop="1110" ELSE '0';
	I_F <= '1' WHEN codop="1111" ELSE '0';

END x;

-- 16 LCs(1 %)

