-- Registro FF.

LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_signed.all;

ENTITY reg_FF IS
PORT(Z,S,C,W:IN std_logic;
	 enable:IN std_logic;
	 FF:INOUT std_logic_vector(15 downto 0));
END reg_FF;

ARCHITECTURE x OF reg_FF IS

BEGIN

	FF(0) <= '1';-- R, el salto incondicional siempre vale '1'
	FF(1) <= Z WHEN enable='1' ELSE FF(1);-- salto segn sea Z
	FF(2) <= S WHEN enable='1' ELSE FF(2);-- salto segn sea S
	FF(3) <= C WHEN enable='1' ELSE FF(3);-- salto segn sea C
	FF(4) <= W WHEN enable='1' ELSE FF(4);-- salto segn sea W
	FF(15 downto 5) <="00000000000";

END x;-- 16 LCs (1 %)

-- 14.9 ns de retraso respecto a 'enable'.
