-- Divisor de frecuencia de entrada entre 2 (pasar de 25 MHz a 12.5 MHz)
LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;

ENTITY div_frec IS
PORT (clock:IN STD_LOGIC;
	  clk_out:OUT STD_LOGIC);
END div_frec;

ARCHITECTURE a OF div_frec IS

BEGIN

	PROCESS(clock)
	VARIABLE control:std_logic:='0';
	BEGIN
		IF clock='1' AND clock'event THEN
			IF control='0' THEN 
				clk_out <= '1';
				control:='1';
			ELSE 
				clk_out <= '0';
				control:='0';
			END IF;
		END IF;
	END PROCESS;

END a;
			
-- 2 LCs (0 %)
