-- Para  DR, AR, PC, IR y RT.

LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_signed.all;

ENTITY registro IS
PORT(bus_in:IN std_logic_vector(15 downto 0);
	 enable:IN std_logic;
	 bus_out:OUT std_logic_vector(15 downto 0));
END registro;

ARCHITECTURE x OF registro IS

BEGIN

	PROCESS(enable,bus_in)
	BEGIN
		IF enable='1' THEN bus_out<=bus_in;
		END IF;
	END PROCESS;

END x;

-- 16 LCs (1 %)

-- Retraso de 15.8 ns de 'bus_out' frente a 'enable'.
-- Retraso de 20 ns de 'bus_out' frente a 'bus_in'.
