LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
USE ieee.std_logic_signed.all;

ENTITY sel2 IS
PORT(u,v,x:IN std_logic;
	 IR_11_0:IN std_logic_vector(11 DOWNTO 0);
	 sel2_out:OUT std_logic_vector(3 DOWNTO 0));
END sel2;

ARCHITECTURE x OF sel2 IS

BEGIN

	sel2_out <= IR_11_0(3 downto 0) WHEN u='0' AND v='0' AND x='0' ELSE
				IR_11_0(7 downto 4) WHEN u='0' AND v='0' AND x='1' ELSE
				IR_11_0(11 downto 8) WHEN u='0' AND v='1' AND x='0' ELSE
				"1101" WHEN u='0' AND v='1' AND x='1' ELSE
				"1110" WHEN u='1' AND v='0' AND x='0';

END x;	
-- 13 LCs (1 %)
-- 19.5 ns de retraso de 'sel2_out' frente a 'uvx' y 21.4 ns frente a 'IR_11_0'
