LIBRARY ieee;
USE ieee.std_logic_1164.all;

ENTITY sel5 IS
PORT(ir0,ir1:IN std_logic;-- ir0 lo meto para poder inicializar a PC
	 sel5_A:IN std_logic_vector(15 DOWNTO 0);
	 sel5_out:OUT std_logic_vector(15 DOWNTO 0));
END sel5;

ARCHITECTURE x OF sel5 IS

BEGIN

	sel5_out <= sel5_A WHEN ir1='0' AND ir0='0' ELSE 
			    "1111100000000000" when ir1='1' AND ir0='0' else -- F800h
				"0000000000000000" when ir0='1';--para inicializar a 0000'h

END x;	

-- 16 LCs (1 %)
-- 15.5 ns de retraso
